summaryrefslogtreecommitdiffstats
path: root/bin/4a-play
diff options
context:
space:
mode:
authorLoïc Collignon <loic.collignon@iot.bzh>2018-07-23 00:48:19 +0200
committerThierry Bultel <thierry.bultel@iot.bzh>2019-04-24 14:18:11 +0200
commitf43f3cb73ff3f8f9c20e8e9efe533ff19e9d3fc6 (patch)
treec385f641368b17aaa93d477896ee8b37facbf655 /bin/4a-play
parenta7d8bd79006b87caf1af58ee4742f94fc59ea0d9 (diff)
Fix issue with the unit file detection
Fix a bug introduced by the commit e4e0b9b, due to the wildcard in the unit file. Change-Id: Iddc47378207a0ced207861433cd0ec02a52bc1a5 Signed-off-by: Loïc Collignon <loic.collignon@iot.bzh>
Diffstat (limited to 'bin/4a-play')
-rwxr-xr-xbin/4a-play56
1 files changed, 48 insertions, 8 deletions
diff --git a/bin/4a-play b/bin/4a-play
index 483b892..620f311 100755
--- a/bin/4a-play
+++ b/bin/4a-play
@@ -4,14 +4,54 @@
. $(dirname $BASH_SOURCE)/lib4a-tools.sh
function usage() {
- log "Usage: $0 <role:file1> [role:file2 ...]"
- log "Available roles:"
- exit 1
+ log "$0 <file> [device] [role]"
+ log " - 'device' can be hw:X where X is a number or the device name."
+ log " It can also be hw:X,Y,Z, it is used when playing on the loopback card"
+ log " which is the 4a default sink."
+ log " Default: hw:Loopback,0,2"
+ log " - 'role' is the 4a role to use. In future version it will be guessed"
+ log " based on the device. Use '4a-api roles' to get a list of known roles"
+ log " Default: multimedia"
}
-[[ $# == 0 ]] && usage
+if [ "$#" == "0" ]; then
+ error "No file to play!"
+ usage
+fi
+
+FILEPATH="$( realpath "$1" )"
+DEVICE=${2:-'hw:Loopback,0,2'}
+ROLE=${3:-'multimedia'}
+
+CARDID=$( echo "$DEVICE" | cut -d':' -f2 | cut -d',' -f1 )
+
+log "Play '$FILEPATH' on '$DEVICE'"
+
+LOOPBACK_CARDID=$( LANG="C" aplay -l | grep -oEe "^card\\s+[0-9]: Loopback" | uniq | grep -oEe "[0-9]+" )
+if [ "$CARDID" == "Loopback" ] || [ "$CARDID" == "$LOOPBACK_CARDID" ]; then
+ IS_4A_DEVICE=1
+else
+ IS_4A_DEVICE=0
+fi
+
+if [ "$IS_4A_DEVICE" == "1" ]; then
+ log "The selected card (hw:$CARDID) is handle by 4a, call open on '$ROLE'"
+ 4a-client ahl-4a "$ROLE" '{ "action": "open" }'
+
+ # BUG: afb-client-demo does not exit an exit code different from zero when api return an error
+ #if [ "$?" -ne "0" ]; then
+ # exit -1
+ #fi
+fi
+
+if [ "$DEBUG" == "1" ]; then
+ gst-launch-1.0 -v uridecodebin uri="file://$FILEPATH" ! audioconvert ! audioresample ! alsasink device="$DEVICE"
+else
+ gst-launch-1.0 -v uridecodebin uri="file://$FILEPATH" ! audioconvert ! audioresample ! alsasink device="$DEVICE" > /dev/null
+fi
+
+if [ "$IS_4A_DEVICE" == "1" ]; then
+ log "The selected card (hw;$CARDID) is handled by 4a, call close on '$ROLE'"
+ 4a-client ahl-4a "$ROLE" '{ "action": "close" }'
+fi
-for x in "$@"; do
- log "Playing $x ..."
- aplay -D Loopback,0,2 $x
-done